﻿using CommunityToolkit.Maui.Converters;

namespace TestProject;

/// <summary>
/// 메인 페이지
/// </summary>
public partial class MainPage : ContentPage
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 선택 값 1 - SelectedValue1

    /// <summary>
    /// 선택 값 1
    /// </summary>
    public int SelectedValue1 { get; set; }

    #endregion
    #region 선택 값 2 - SelectedValue2

    /// <summary>
    /// 선택 값 2
    /// </summary>
    public int SelectedValue2 { get; set; }

    #endregion
    #region 선택 값 3 - SelectedValue3

    /// <summary>
    /// 선택 값 3
    /// </summary>
    public int SelectedValue3 { get; set; }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 생성자 - MainPage()

    /// <summary>
    /// 생성자
    /// </summary>
    public MainPage()
    {
        InitializeComponent();

        SelectedValue1 = 10;
        SelectedValue2 = 0;
        SelectedValue3 = 1;

        VariableMultiValueConverter converter = new VariableMultiValueConverter();

        converter.ConditionType = MultiBindingCondition.LessThan;
        converter.Count         = 2;

        List<BindingBase> bindingBaseList = new List<BindingBase>();

        bindingBaseList.Add(new Binding(nameof(SelectedValue1)));
        bindingBaseList.Add(new Binding(nameof(SelectedValue2)));
        bindingBaseList.Add(new Binding(nameof(SelectedValue3)));

        MultiBinding binding = new MultiBinding();

        binding.Converter = converter;
        binding.Bindings  = bindingBaseList;

        this.label.SetBinding(Label.TextProperty, binding);

        BindingContext = this;
    }

    #endregion
}